import { ChainName, PlatformName } from '@wormhole-foundation/sdk-base';
import { NativeAddress, UniversalAddress, VAA, Signer, TxHash, WormholeMessageId, TransactionId, CircleAttestation, CircleMessageId } from '@wormhole-foundation/sdk-definitions';
import { CCTPTransferDetails } from '../types';
import { WormholeTransfer, TransferState, AttestationId } from '../wormholeTransfer';
import { Wormhole } from '../wormhole';
export declare class CCTPTransfer implements WormholeTransfer {
    private readonly wh;
    private state;
    transfer: CCTPTransferDetails;
    txids?: TxHash[];
    circleAttestations?: {
        id: CircleMessageId;
        attestation?: CircleAttestation;
    }[];
    vaas?: {
        id: WormholeMessageId;
        vaa?: VAA<'CircleTransferRelay'>;
    }[];
    private constructor();
    getTransferState(): Promise<TransferState>;
    static from(wh: Wormhole, from: CCTPTransferDetails): Promise<CCTPTransfer>;
    static from(wh: Wormhole, from: WormholeMessageId): Promise<CCTPTransfer>;
    static from(wh: Wormhole, from: TransactionId): Promise<CCTPTransfer>;
    private static fromIdentifier;
    private static fromTransaction;
    initiateTransfer(signer: Signer): Promise<TxHash[]>;
    private fetchWormholeAttestation;
    private fetchCircleAttestation;
    fetchAttestation(timeout: number): Promise<AttestationId[]>;
    completeTransfer(signer: Signer): Promise<TxHash[]>;
    static getTransferVaa(wh: Wormhole, chain: ChainName, emitter: UniversalAddress | NativeAddress<PlatformName>, sequence: bigint, retries?: number): Promise<VAA<'CircleTransferRelay'>>;
}
//# sourceMappingURL=cctpTransfer.d.ts.map